function retval = det (KP)
  [n, m] = size (KP.A);
  [q, r] = size (KP.B);
  if (n == m && q == r) # A and B are both square
    retval = (det (KP.A)^q) * (det (KP.B)^n);
  elseif (n*q == m*r) # kron (A, B) is square
    ## XXX: Can we do something smarter here?
    retval = det (full (KP));
  else
    error ("det: argument must be a square matrix");
  endif
endfunction
