function retval = mpower (KP, k)
  if (issquare (KP.A) && issquare (KP.B))
    retval = kronprod (KP.A^k, KP.B^k);
  elseif (issquare (KP))
    ## XXX: Can we do something smarter here?
    retval = full (KP)^ḱ;
  else
    error ("for A^b, A must be square");
  endif
endfunction
